
#ifdef PLANAR

void testCute(MyInterval x, MyInterval y,
              int rExp, int bExp)
{

    MyInterval qxCute, qyCute;
    MyInterval qx, qy;
    cuteCalculation(x, y, qxCute, qyCute, rExp, bExp);

    MyInterval r = sqrt(power(x, 2) + power(y, 2));
    qx = power(x, bExp) * power(r, -rExp);
    qy = power(y, bExp) * power(r, -rExp);

    if (!subSet(qxCute, qx))
    {
        cout << "BLAD! cute na X daje gorszy wynik!" << endl;
    }

    if (!subSet(qyCute, qy))
    {
        cout << "BLAD! cute na Y daje gorszy wynik!" << endl;
    }

    cout << "qx = " << qx << ", qxCute = " << qxCute << endl;
    cout << "qy = " << qy << ", qyCute = " << qyCute << endl;

    MyDouble d = diam(qx);
    MyDouble dC = diam(qxCute);
    cout << "zysk(%) = " << (1 - dC / d) * 100 << endl;
}

void superTestCute()
{
    MyInterval x = MyInterval(-0.5, 0.5);
    MyInterval y = MyInterval(0.1, 0.2);
    int rExp = 3;
    int bExp = 1;

    for (int i = 0; i < 10; i++)
    {
        cout << "diam x = " << diam(x) << ", diam y = " << diam(y) << endl;
        MyInterval r = sqrt(power(x, 2) + power(y, 2));
        cout << "diam r/r.leftBound() = " << diam(r) / r.leftBound() << endl;
        testCute(x, y, rExp, bExp);
        cout << endl;

        x *= 0.25;
    }
}
#endif

#ifdef SPATIAL
void testCute(MyInterval x, MyInterval y, MyInterval z,
              int rExp, int bExp)

{

    MyInterval qxCute, qyCute, qzCute;
    MyInterval qx, qy, qz;
    MyInterval r = sqrt(power(x, 2) + power(y, 2) + power(z, 2));
    biasCute = 0.0;
    cuteCalculation(x, y, z, qxCute, qyCute, qzCute, rExp, bExp);
    biasCute = 1000.0;
    cuteCalculation(x, y, z, qx, qy, qz, rExp, bExp);

    if (!subSetInterior(qxCute, qx))
    {
        cout << "BLAD! cute na X daje gorszy wynik!" << endl;
    }

    if (!subSetInterior(qyCute, qy))
    {
        cout << "BLAD! cute na Y daje gorszy wynik!" << endl;
    }

    if (!subSetInterior(qzCute, qz))
    {
        cout << "BLAD! cute na Z daje gorszy wynik!" << endl;
    }

    cout << "qx = " << qx << ", qxCute = " << qxCute << endl;
    cout << "qy = " << qy << ", qyCute = " << qyCute << endl;
    cout << "qz = " << qz << ", qzCute = " << qzCute << endl;
}

void superTestCute()
{
    MyInterval x = MyInterval(0.1, 0.2);
    MyInterval y = MyInterval(-0.1, 0.1);
    MyInterval z = MyInterval(-0.1, 0.2);
    int rExp = 3;
    int bExp = 1;

    testCute(x, y, z, rExp, bExp);
}

#endif

